unit USample;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvSmoothPanel, Vcl.StdCtrls, AdvGDIP;

type
  TAdvSmoothPanelProtected = class(TAdvSmoothPanel);

  TForm130 = class(TForm)
    AdvSmoothPanel1: TAdvSmoothPanel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form130: TForm130;

implementation

{$R *.dfm}

uses
  ActiveX;

function GetCLSID(ImageType: TImageType): TCLSID;
var
  I: integer;
  num, numi, size: Cardinal;
  clsId: TCLSID;
  pinfo: PImageCodecInfo;
  infoarr: array[0..100] of TImageCodecInfo;
  str: String;
begin
  GdipGetImageEncodersSize(num, size);

  pinfo := AllocMem(size);

  numi := num;

  GdipGetImageEncoders(num, size, pinfo);

  move(pinfo^, infoarr[0], size);

  case ImageType of
    itPNG: str := 'image/png';
    itBMP: str := 'image/bmp';
    itJPEG: str := 'image/jpeg';
    itTIFF: str := 'image/tiff';
    itGIF: str := 'image/gif';
  end;

  for I := 0 to numi - 1 do
  begin
    if infoarr[i].MimeType = str then
    begin
      clsid := infoarr[i].Clsid;
      break;
    end;
  end;

  FreeMem(pinfo);

  Result := clsid;
end;

procedure TForm130.Button1Click(Sender: TObject);
var
  gpbmp: TGPBitmap;
  g: TGPGraphics;
  enc: TEncoderParameters;
begin
  gpbmp := TGPBitmap.Create(AdvSmoothPanel1.Width, AdvSmoothPanel1.Height);

  g := TGPGraphics.Create(gpbmp);


  TAdvSmoothPanelProtected(AdvSmoothPanel1).GDIPPaint(g);

  enc.Count := 1;
  enc.Parameter[0].Guid := EncoderQuality;
  enc.Parameter[0].NumberOfValues := 1;
  enc.Parameter[0].Type_ := EncoderParameterValueTypeLong;
  enc.Parameter[0].Value := Pointer(100);

  gpbmp.Save('test.png', GetCLSID(itPNG), @enc);

  g.Free;
  gpbmp.Free;
end;

procedure TForm130.FormCreate(Sender: TObject);
begin
  AdvSmoothPanel1.Caption.Text := '';
  AdvSmoothPanel1.Fill.Rounding := AdvSmoothPanel1.Height div 2;
end;

end.
